<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files

require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning.'functions/common_functions.php';

require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}


validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

function getAllSubject($conn_rjllearning_specific, $institution_id,$class_id, $search_string, $limit, $offset)
{

    $sql = "SELECT  count(*) as total_rows FROM  subject_info  where institution_id =? and class_id= ? and subject_name LIKE ?";
    $array_params = [$institution_id,$class_id, '%' . $search_string . '%'];
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
    
   if ($limit == 'all') {
    $sql = "SELECT * FROM  subject_info  where institution_id =? and  class_id= ? and subject_name LIKE ? ";
    $array_params = [$institution_id,$class_id, '%' . $search_string . '%'];
   }else{
    $sql = "SELECT * FROM  subject_info  where institution_id =? and  class_id= ? and subject_name LIKE ? LIMIT " . $offset . " ," . $limit . " ";
    $array_params = [$institution_id,$class_id, '%' . $search_string . '%'];
   }
   
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();
    $array_return = [];

    foreach ($result as $rows) {
        // if ($rows['icon'] != null and !is_array($rows['icon'])) {
        //     $data_attachment = json_decode($rows['icon'], true);
        //     $filePath = $data_attachment['filepath'];
        //     $originalName = $data_attachment['original_name'];
        //     $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
        //     //$final_array_icon   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        // } else {
        //     $aws_attachment =  null;
        // }
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
       
        $array_return[] =  array('subject_id' => $rows['id'], 'class_id' => $class_info, 'type' => $rows['type'], 'subject_name' => $rows['subject_name'],
        // 'icon' => $aws_attachment
        );
    }

    if (count($result) < 50) {

        return array('total_rows' => $totalrows, 'subject_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'subject_info' => $array_return, 'maxreach' => 0);
    }
}

if ($postdata['function_type']  == "fetch_subject") {
   
    // $institution_id = trim($postdata['institution_id']);
     $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }
    // $branch_id = ($postdata['branch_id']);
    // $class_id = ($postdata['class_id']);
     if (isset($postdata['class_id']) and !empty($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = null;
    }
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    if($limit != 'all'){
        $offset = ($page - 1) * $limit;
        $success['data'] = getAllSubject($conn_rjllearning_specific, $institution_id,$class_id, $search_string, $limit, $offset);
        successreturn($success);
    }else{
        $success['data'] = getAllSubject($conn_rjllearning_specific, $institution_id,$class_id, $search_string, $limit, null);
        successreturn($success);
        
    }
}

